import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

int bufferSize = 512;
int sampleRate = 44100;

Minim minim;
AudioOutput out;
Oscil osc;
Noise noise;
Oscil lfo;
LowPassFS lowpass;

FFT fft;

void setup()
{
  size(bufferSize,300);
  minim = new Minim(this);
  out = minim.getLineOut(Minim.STEREO, 512);
  osc = new Oscil(440, 1, Waves.SINE);
  lfo = new Oscil(1, 1, Waves.SINE);
  //lfo.patch(osc.amplitude);
  lowpass = new LowPassFS(1000, sampleRate);
  fft = new FFT(bufferSize, sampleRate);

  osc.patch(lowpass);
  lowpass.patch(out);
}

void draw()
{
  background(0);
  stroke(255);
  
  //float freq = map(mouseX, 0, width, 0, 1000);
  //osc.setFrequency(freq);
  
  fft.forward(out.mix);
  
  int offset = 50;
  int scale = 50;
  for(int i = 0; i < out.bufferSize() - 1; i++)
  {
    line(i, offset + out.left.get(i)*scale, i+1, offset + out.left.get(i+1)*scale);
    line(i, 2*offset + out.right.get(i)*scale, i+1, 2*offset + out.right.get(i+1)*scale);
  }
  
  for(int i = 0; i < fft.specSize(); i++){
     int xPos = floor(map(i, 0, fft.specSize(), 0, width));
     float amp = fft.getBand(i);
     line(xPos, height, xPos, height - amp);
  }

}

void stop() // required when using Minium
{
  out.close();
  minim.stop();
  super.stop();
}


